import _Drawer from "antd/es/drawer";
import _extends from "@babel/runtime/helpers/extends";
import _Button from "antd/es/button";
import { observer, useFieldSchema } from '@formily/react';
import cls from 'classnames';
import { useState } from 'react';
import useStyle from './style';
import { usePrefixCls } from '@formily/antd-v5/lib/__builtins__';
import { ArrayBase } from '@formily/antd-v5';
import { isSidePanelComponent } from '../common';
import { useSubSlotRef } from '../../../context';
import { ValidatorSetter } from '../validator-setter';
export var SideContent = observer(function (props) {
  var array = ArrayBase.useArray();
  var schema = useFieldSchema();
  var _useState = useState(false),
    open = _useState[0],
    setOpen = _useState[1];
  var slotRef = useSubSlotRef();
  var prefixCls = usePrefixCls('side-content-drawer', props);
  var _useStyle = useStyle(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  if (!schema) throw new Error('can not found schema object');
  var itemsSchema = Array.isArray(array.schema.items) ? array.schema.items[0] : array.schema.items;
  var _props = {
    title: ''
  };
  itemsSchema.mapProperties(function (schema) {
    if (isSidePanelComponent(schema)) {
      _props = schema['x-component-props'];
    }
  });
  return wrapSSR(/*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_Button, {
    color: "primary",
    variant: "filled",
    size: "small",
    onClick: function onClick() {
      setOpen(true);
    }
  }, _props.title), /*#__PURE__*/React.createElement(_Drawer, {
    width: 400,
    open: open,
    rootStyle: {
      position: 'absolute'
    },
    push: false,
    onClose: function onClose() {
      return setOpen(false);
    },
    getContainer: function getContainer() {
      return slotRef.current;
    },
    mask: false,
    rootClassName: cls(prefixCls, hashId),
    classNames: {
      header: prefixCls + "-drawer-header"
    }
  }, /*#__PURE__*/React.createElement(ValidatorSetter, _extends({
    setOpen: setOpen
  }, _props)))));
});