import _Button from "antd/es/button";
import _extends from "@babel/runtime/helpers/extends";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["className", "style", "children", "buttonProps"];
import _regeneratorRuntime from "@babel/runtime/regenerator";
import { usePrefixCls } from '@formily/antd-v5/lib/__builtins__';
import { observer, useField } from '@formily/react';
import { isValid } from '@formily/shared';
import cls from 'classnames';
import { useStyle } from './style';
import { createIcon, isJSExpression } from '@gant-lowcode/lowcode-utils';
import { useEvent } from '../../../../hooks/useEvent';
import { useSelected } from '../../../../hooks';
import { FormItem } from '@formily/antd-v5';
import { useMemo } from 'react';
var isHTMLInputEvent = function isHTMLInputEvent(event, stopPropagation) {
  if (stopPropagation === void 0) {
    stopPropagation = true;
  }
  if (event !== null && event !== void 0 && event.target) {
    var _event$stopPropagatio;
    if (typeof event.target === 'object' && ('value' in event.target || 'checked' in event.target)) return true;
    if (stopPropagation) (_event$stopPropagatio = event.stopPropagation) === null || _event$stopPropagatio === void 0 ? void 0 : _event$stopPropagatio.call(event);
  }
  return false;
};
var getValuesFromEvent = function getValuesFromEvent(args) {
  return args.map(function (event) {
    if (event !== null && event !== void 0 && event.target) {
      if (isValid(event.target.value)) return event.target.value;
      if (isValid(event.target.checked)) return event.target.checked;
      return;
    }
    return event;
  });
};
var getValues = function getValues(args) {
  var _args$;
  if ((_args$ = args[0]) !== null && _args$ !== void 0 && _args$.target) {
    if (!isHTMLInputEvent(args[0])) return args;
  }
  return getValuesFromEvent(args);
};
export var MixedSetter = observer(function (_ref) {
  var className = _ref.className,
    style = _ref.style,
    children = _ref.children,
    buttonProps = _ref.buttonProps,
    props = _objectWithoutPropertiesLoose(_ref, _excluded);
  var event = useEvent();
  var field = useField();
  var selected = useSelected();
  var prefixCls = usePrefixCls('mixed-setter');
  var _useStyle = useStyle(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var getMockOrValue = function getMockOrValue(v) {
    if (isJSExpression(v)) {
      return v.mock;
    }
    return v;
  };
  var _useMemo = useMemo(function () {
      var oldOnInput = field.onInput;
      var oldValue = field.value ? JSON.parse(JSON.stringify(field.value)) : undefined;
      var onInput = /*#__PURE__*/function () {
        var _ref2 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
          var _len,
            args,
            _key,
            values,
            value,
            _args = arguments;
          return _regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) switch (_context.prev = _context.next) {
              case 0:
                for (_len = _args.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
                  args[_key] = _args[_key];
                }
                console.log('--onChange-args', args);
                values = getValues(args);
                value = values[0];
                console.log('--onChange-value', value);
                if (isJSExpression(oldValue)) {
                  oldOnInput === null || oldOnInput === void 0 ? void 0 : oldOnInput(_extends({}, oldValue, {
                    mock: value
                  }));
                } else {
                  oldOnInput === null || oldOnInput === void 0 ? void 0 : oldOnInput(value);
                }
              case 6:
              case "end":
                return _context.stop();
            }
          }, _callee);
        }));
        return function onInput() {
          return _ref2.apply(this, arguments);
        };
      }();
      field.onInput = onInput;
      field.value = getMockOrValue(oldValue);
      return {
        oldValue: oldValue,
        oldOnInput: oldOnInput
      };
    }, []),
    oldValue = _useMemo.oldValue,
    oldOnInput = _useMemo.oldOnInput;
  var onBindChange = function onBindChange(value) {
    console.log('-onBindChange--value', value, oldOnInput);
    oldOnInput === null || oldOnInput === void 0 ? void 0 : oldOnInput(value);
  };
  var show = function show() {
    // 打开绑定变量面板
    event.emit('variableBind.open', _extends({}, props, {
      onChange: onBindChange
    }), field, selected);
  };
  var extra = /*#__PURE__*/React.createElement(_Button, _extends({
    size: "small"
  }, buttonProps, {
    onClick: show
  }), createIcon('fx', {
    className: cls(prefixCls + "-icon", {
      active: isJSExpression(oldValue)
    }),
    style: {
      fontSize: 12
    }
  }));
  return wrapSSR(/*#__PURE__*/React.createElement(FormItem, _extends({
    className: cls(prefixCls, hashId, className),
    style: style
  }, props, {
    extra: extra
  }), children));
});