import _Tabs from "antd/es/tabs";
import _Empty from "antd/es/empty";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["className", "fieldNames", "children"];
import { observer, RecursionField, Schema, useField, useFieldSchema } from '@formily/react';
import cls from 'classnames';
import React, { useState } from 'react';
import useStyle from './style';
import { usePrefixCls } from '@formily/antd-v5/lib/__builtins__';
import { isEmpty } from 'lodash';
import { useSelected } from '../../../../hooks';
import { FormPath } from '@formily/shared';
export var ValidatorSetter = observer(function (props) {
  var className = props.className,
    _props$fieldNames = props.fieldNames,
    fieldNames = _props$fieldNames === void 0 ? {
      label: 'label',
      value: 'value'
    } : _props$fieldNames,
    children = props.children,
    restProps = _objectWithoutPropertiesLoose(props, _excluded);
  console.log('ValidatorSetter-----props', props);
  var field = useField();
  var schema = useFieldSchema();
  console.log('-ValidatorSetter--schema', schema.toJSON(), field);
  var form = field.form;
  var selected = useSelected();
  var _useState = useState(),
    stateActiveTabKey = _useState[0],
    setStateActiveTabKey = _useState[1];
  var prefixCls = usePrefixCls('validator-setter', props);
  var _useStyle = useStyle(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var onTabChange = function onTabChange(key) {
    setStateActiveTabKey(key);
  };
  if (!schema) throw new Error('can not found schema object');
  var definitions = selected.getStatementStateDefinitions();
  var isStateRules = definitions && !isEmpty(definitions);
  var itemsSchema = new Schema(schema.toJSON(), schema.parent);
  console.log('---definitions', definitions, isStateRules, itemsSchema.toJSON());
  var basePath = '';
  schema.mapProperties(function (item, key) {
    basePath = key.toString();
  });
  var currentTabKey = '';
  var tabList = undefined;
  if (isStateRules) {
    var _Object$keys;
    currentTabKey = stateActiveTabKey || ((_Object$keys = Object.keys(definitions)) === null || _Object$keys === void 0 ? void 0 : _Object$keys[0]);
    basePath = basePath + "__state__." + currentTabKey;
    tabList = Object.entries(definitions).map(function (_ref) {
      var key = _ref[0],
        label = _ref[1];
      return {
        key: key,
        label: label
      };
    });
    // 构建状态 schema
    itemsSchema.mapProperties(function (schema, key) {
      var _properties, _stateSchema;
      var stateSchema = (_stateSchema = {}, _stateSchema[key + "__state__"] = {
        type: 'object',
        properties: (_properties = {}, _properties[currentTabKey] = schema.toJSON(), _properties)
      }, _stateSchema);
      itemsSchema.setProperties(stateSchema);
      itemsSchema.removeProperty(key);
    });
  }
  var value = FormPath.getIn(form.values, basePath) || [];
  var isRuleEmpty = value.length === 0;
  var renderEmpty = function renderEmpty() {
    if (!isRuleEmpty) return;
    return /*#__PURE__*/React.createElement(_Empty, {
      description: "\u6682\u65E0\u6821\u9A8C\u89C4\u5219"
    });
  };
  var renderItems = function renderItems() {
    return /*#__PURE__*/React.createElement(RecursionField, {
      schema: itemsSchema
    });
  };
  return wrapSSR(/*#__PURE__*/React.createElement("div", {
    className: cls(prefixCls, hashId)
  }, tabList && tabList.length > 0 && /*#__PURE__*/React.createElement(_Tabs, {
    className: prefixCls + "-tabs",
    items: tabList,
    size: "small",
    onChange: onTabChange,
    tabBarGutter: 12
  }), renderEmpty(), renderItems()));
});