import React, { useMemo } from 'react';
import { createForm } from '@formily/core';
import cls from 'classnames';
import { get } from 'lodash';
import { usePrefixCls } from '@formily/antd-v5/lib/__builtins__';
import { Form, SchemaField } from './schema-field';
import { useMaterial } from '../../../hooks';
import { onFieldDiffValueChange } from './utils';
export function SettingsForm(_ref) {
  var className = _ref.className,
    style = _ref.style,
    settings = _ref.settings,
    schema = _ref.schema,
    components = _ref.components,
    scope = _ref.scope;
  var formWrapperCls = usePrefixCls('settings-form-wrapper');
  var material = useMaterial();
  var form = useMemo(function () {
    var _component$snippets, _component$snippets$, _component$snippets$$;
    var values = settings.getValue();
    var assets = material.getAssets();
    var _settings$getNode = settings.getNode(),
      componentName = _settings$getNode.componentName;
    var component = assets.components.find(function (item) {
      return item.componentName === componentName;
    });
    var initialValues = component === null || component === void 0 ? void 0 : (_component$snippets = component.snippets) === null || _component$snippets === void 0 ? void 0 : (_component$snippets$ = _component$snippets[0]) === null || _component$snippets$ === void 0 ? void 0 : (_component$snippets$$ = _component$snippets$.schema) === null || _component$snippets$$ === void 0 ? void 0 : _component$snippets$$.props;
    console.log('SettingsForm---initialValues', initialValues);
    console.log('SettingsForm---values', values, settings.getNode());
    return createForm({
      initialValues: initialValues,
      values: values,
      effects: function effects() {
        var valueChange = function valueChange(field) {
          if (get(field.data, 'virtual') === true || get(field.parent.data, 'virtual') === true) return;
          var value = field.value;
          var key = field.path.toString();
          console.log('---key, value', key, value);
          settings.setPropValue(key, value);
        };
        onFieldDiffValueChange('*', valueChange);
      }
    });
  }, [settings]);
  return /*#__PURE__*/React.createElement(Form, {
    className: cls('lc-settings-form', formWrapperCls, className),
    form: form,
    style: style,
    labelAlign: "left",
    feedbackLayout: "terse",
    labelCol: 6,
    colon: false
  }, /*#__PURE__*/React.createElement(SchemaField, {
    schema: schema,
    components: components,
    scope: scope
  }));
}