"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.useValueMode = exports.useRowSelectedContext = exports.useGridManagerRef = exports.useFieldDataSource = exports.useBatchRemove = exports.useArrayTableSources = exports.useArrayTableColumns = exports.useAddition = exports.useAction = exports.isSidePanelComponent = exports.isSideAdditionComponent = exports.isOperationsComponent = exports.isOperationComponent = exports.isOpenComponent = exports.isIndexComponent = exports.isColumnComponent = exports.isBatchRemoveComponent = exports.isAdditionComponent = exports.isActionComponent = exports.indexKey = exports.ValueModeContext = exports.SidePanel = exports.RowSelectedContext = exports.Navigation = exports.LOWCODE_NODE_ID = exports.GridManagerContext = exports.FieldDataSourceContext = exports.Column = exports.BatchRemove = exports.Addition = exports.Action = void 0;
var _button = _interopRequireDefault(require("antd/lib/button"));
var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = require("@formily/react");
var _shared = require("@formily/shared");
var _classnames = _interopRequireDefault(require("classnames"));
var _react2 = _interopRequireWildcard(require("react"));
var _style = _interopRequireDefault(require("./style"));
var _builtins__ = require("@formily/antd-v5/lib/__builtins__");
var _antdV = require("@formily/antd-v5");
var _hooks = require("../../../../hooks");
var _icons = require("@ant-design/icons");
var _lodash = require("lodash");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var isIndexComponent = exports.isIndexComponent = function isIndexComponent(schema) {
  var _schema$xComponent, _schema$xComponent$in;
  return ((_schema$xComponent = schema['x-component']) === null || _schema$xComponent === void 0 ? void 0 : (_schema$xComponent$in = _schema$xComponent.indexOf) === null || _schema$xComponent$in === void 0 ? void 0 : _schema$xComponent$in.call(_schema$xComponent, 'Index')) > -1;
};
var isColumnComponent = exports.isColumnComponent = function isColumnComponent(schema) {
  var _schema$xComponent2;
  return ((_schema$xComponent2 = schema['x-component']) === null || _schema$xComponent2 === void 0 ? void 0 : _schema$xComponent2.indexOf('Column')) > -1;
};
var isSidePanelComponent = exports.isSidePanelComponent = function isSidePanelComponent(schema) {
  var _schema$xComponent3;
  return ((_schema$xComponent3 = schema['x-component']) === null || _schema$xComponent3 === void 0 ? void 0 : _schema$xComponent3.indexOf('SidePanel')) > -1;
};
var isSideAdditionComponent = exports.isSideAdditionComponent = function isSideAdditionComponent(schema) {
  var _schema$xComponent4;
  return ((_schema$xComponent4 = schema['x-component']) === null || _schema$xComponent4 === void 0 ? void 0 : _schema$xComponent4.indexOf('AddSidePanel')) > -1;
};
var isOperationsComponent = exports.isOperationsComponent = function isOperationsComponent(schema) {
  var _schema$xComponent5;
  return ((_schema$xComponent5 = schema['x-component']) === null || _schema$xComponent5 === void 0 ? void 0 : _schema$xComponent5.indexOf('Operations')) > -1;
};
var isAdditionComponent = exports.isAdditionComponent = function isAdditionComponent(schema) {
  var _schema$xComponent6;
  return ((_schema$xComponent6 = schema['x-component']) === null || _schema$xComponent6 === void 0 ? void 0 : _schema$xComponent6.indexOf('Addition')) > -1;
};
var isRemoveComponent = function isRemoveComponent(schema) {
  var _schema$xComponent7, _schema$xComponent7$i;
  return ((_schema$xComponent7 = schema['x-component']) === null || _schema$xComponent7 === void 0 ? void 0 : (_schema$xComponent7$i = _schema$xComponent7.indexOf) === null || _schema$xComponent7$i === void 0 ? void 0 : _schema$xComponent7$i.call(_schema$xComponent7, 'Remove')) > -1;
};
var isMoveUpComponent = function isMoveUpComponent(schema) {
  var _schema$xComponent8, _schema$xComponent8$i;
  return ((_schema$xComponent8 = schema['x-component']) === null || _schema$xComponent8 === void 0 ? void 0 : (_schema$xComponent8$i = _schema$xComponent8.indexOf) === null || _schema$xComponent8$i === void 0 ? void 0 : _schema$xComponent8$i.call(_schema$xComponent8, 'MoveUp')) > -1;
};
var isMoveDownComponent = function isMoveDownComponent(schema) {
  var _schema$xComponent9, _schema$xComponent9$i;
  return ((_schema$xComponent9 = schema['x-component']) === null || _schema$xComponent9 === void 0 ? void 0 : (_schema$xComponent9$i = _schema$xComponent9.indexOf) === null || _schema$xComponent9$i === void 0 ? void 0 : _schema$xComponent9$i.call(_schema$xComponent9, 'MoveDown')) > -1;
};
var isOperationComponent = exports.isOperationComponent = function isOperationComponent(schema) {
  return isAdditionComponent(schema) || isRemoveComponent(schema) || isMoveDownComponent(schema) || isMoveUpComponent(schema);
};
var getDisplayStatus = function getDisplayStatus(mode, columnEnv) {
  var isMatch = (0, _lodash.isString)(columnEnv) ? columnEnv === mode : columnEnv.includes(mode);
  return mode === 'normal' ? isMatch ? 'visible' : 'hidden' : isMatch ? 'visible' : 'none';
};
var useArrayTableSources = exports.useArrayTableSources = function useArrayTableSources(arrayField, schema, mode) {
  if (mode === void 0) {
    mode = 'normal';
  }
  return (0, _react2.useMemo)(function () {
    var _parseSources = function parseSources(schema) {
      if (isColumnComponent(schema) || isOperationsComponent(schema) || isAdditionComponent(schema)) {
        var _schema$xComponentP, _field$component;
        var xComponentProps = schema['x-component-props'] || {};
        if (!xComponentProps['dataIndex'] && !schema['name']) return [];
        var _display = undefined;
        var name = ((_schema$xComponentP = schema['x-component-props']) === null || _schema$xComponentP === void 0 ? void 0 : _schema$xComponentP['dataIndex']) || schema['name'];
        var field = arrayField.query(arrayField.address.concat(name)).take();
        if (mode === 'normal') {
          var columnEnv = xComponentProps['env'];
          _display = columnEnv ? getDisplayStatus(mode, columnEnv) : 'none';
        } else {
          var _columnEnv = xComponentProps['env'];
          if (_columnEnv) {
            _display = _columnEnv ? getDisplayStatus(mode, _columnEnv) : 'none';
          }
        }
        var columnProps = (field === null || field === void 0 ? void 0 : (_field$component = field.component) === null || _field$component === void 0 ? void 0 : _field$component[1]) || xComponentProps;
        var display = _display || (field === null || field === void 0 ? void 0 : field.display) || schema['x-display'];
        return [{
          name: name,
          display: display,
          field: field,
          schema: schema,
          columnProps: columnProps
        }];
      } else if (schema.properties) {
        return schema.reduceProperties(function (buf, schema) {
          return buf.concat(_parseSources(schema));
        }, []);
      }
      return [];
    };
    var parseArrayItems = function parseArrayItems(schema) {
      if (!schema) return [];
      var sources = [];
      var items = (0, _shared.isArr)(schema) ? schema : [schema];
      return items.reduce(function (columns, schema) {
        var item = _parseSources(schema);
        if (item) {
          return columns.concat(item);
        }
        return columns;
      }, sources);
    };
    if (!schema) throw new Error('can not found schema object');
    return parseArrayItems(schema.items);
  }, [arrayField, schema, mode]);
};
var createCellEditor = function createCellEditor(field, schema) {
  var CellEditor = /*#__PURE__*/(0, _react2.memo)(function (props) {
    var _field$query;
    var index = props.data[indexKey];
    var keys = [];
    schema.mapProperties(function (property, key) {
      if (property.type !== 'boolean') {
        keys.push(key);
      }
    });
    var path = field.address.concat(index + '.' + keys[0]);
    var self = (_field$query = field.query(path)) === null || _field$query === void 0 ? void 0 : _field$query.take();
    self === null || self === void 0 ? void 0 : self.setPattern('editable');
    var children = /*#__PURE__*/_react2["default"].createElement(_antdV.ArrayBase.Item, {
      index: index,
      record: function record() {
        var _field$value;
        return field === null || field === void 0 ? void 0 : (_field$value = field.value) === null || _field$value === void 0 ? void 0 : _field$value[index];
      }
    }, /*#__PURE__*/_react2["default"].createElement(_react.RecursionField, {
      schema: schema,
      name: index,
      onlyRenderProperties: true
    }));
    return index > -1 ? children : null;
  });
  return CellEditor;
};
var LOWCODE_NODE_ID = exports.LOWCODE_NODE_ID = '__lowcode_node_id__';
var indexKey = exports.indexKey = '__DO_NOT_USE_THIS_PROPERTY_index__';
var useArrayTableColumns = exports.useArrayTableColumns = function useArrayTableColumns(dataSource, field, sources) {
  return (0, _react2.useMemo)(function () {
    return sources.reduce(function (buf, _ref, key) {
      var name = _ref.name,
        columnProps = _ref.columnProps,
        schema = _ref.schema,
        display = _ref.display;
      if (display !== 'visible') return buf;
      if (!isColumnComponent(schema)) return buf;
      var render = undefined;
      var fieldName = undefined;
      var editable = columnProps.editable;
      var editableUi = false;
      // 不可编辑时，用 render 来渲染单元格
      if (!editable) {
        render = function render(value, record) {
          var index = record[indexKey];
          var children = /*#__PURE__*/_react2["default"].createElement(_antdV.ArrayBase.Item, {
            index: index,
            record: function record() {
              var _field$value2;
              return field === null || field === void 0 ? void 0 : (_field$value2 = field.value) === null || _field$value2 === void 0 ? void 0 : _field$value2[index];
            }
          }, /*#__PURE__*/_react2["default"].createElement(_react.RecursionField, {
            schema: schema,
            name: index,
            onlyRenderProperties: true
          }));
          return index > -1 ? children : null;
        };
      } else {
        // field?.setPattern('readPretty');
        // 可编辑时，用 cellEditor 来渲染单元格
        fieldName = name;
        var keys = [];
        schema.mapProperties(function (property, key) {
          if (property.type !== 'boolean') {
            property['x-pattern'] = 'readPretty';
            keys.push(key);
          } else {
            editable = false;
            editableUi = true;
          }
        });
        render = function render(value, record) {
          var _field$query2;
          var index = record[indexKey];
          var path = field.address.concat(index + '.' + keys[0]);
          var self = (_field$query2 = field.query(path)) === null || _field$query2 === void 0 ? void 0 : _field$query2.take();
          self === null || self === void 0 ? void 0 : self.setPattern('readPretty');
          var children = /*#__PURE__*/_react2["default"].createElement(_antdV.ArrayBase.Item, {
            index: index,
            record: function record() {
              var _field$value3;
              return field === null || field === void 0 ? void 0 : (_field$value3 = field.value) === null || _field$value3 === void 0 ? void 0 : _field$value3[index];
            }
          }, /*#__PURE__*/_react2["default"].createElement(_react.RecursionField, {
            schema: schema,
            name: index,
            onlyRenderProperties: true
          }));
          return index > -1 ? children : null;
        };
      }
      return buf.concat((0, _extends3["default"])({}, (0, _lodash.omit)(columnProps, 'env'), {
        editable: editable,
        fieldName: fieldName,
        cellEditor: createCellEditor(field, schema),
        cellClassRules: {
          'gant-grid-cell-edit': function gantGridCellEdit(params) {
            return editable || editableUi;
          }
        },
        render: render
      }));
    }, []);
  }, [field, sources]);
};
var useAddition = exports.useAddition = function useAddition(schema) {
  return schema.reduceProperties(function (addition, schema, key) {
    if (isAdditionComponent(schema)) {
      return /*#__PURE__*/_react2["default"].createElement(_react.RecursionField, {
        schema: schema,
        name: key
      });
    }
    return addition;
  }, null);
};
var FieldDataSourceContext = exports.FieldDataSourceContext = /*#__PURE__*/(0, _react2.createContext)(undefined);
var useFieldDataSource = exports.useFieldDataSource = function useFieldDataSource() {
  return (0, _react2.useContext)(FieldDataSourceContext);
};
var ValueModeContext = exports.ValueModeContext = /*#__PURE__*/(0, _react2.createContext)('');
var useValueMode = exports.useValueMode = function useValueMode() {
  return (0, _react2.useContext)(ValueModeContext);
};
var RowSelectedContext = exports.RowSelectedContext = /*#__PURE__*/(0, _react2.createContext)([]);
var useRowSelectedContext = exports.useRowSelectedContext = function useRowSelectedContext() {
  return (0, _react2.useContext)(RowSelectedContext);
};
var GridManagerContext = exports.GridManagerContext = /*#__PURE__*/(0, _react2.createContext)({
  current: null
});
var useGridManagerRef = exports.useGridManagerRef = function useGridManagerRef() {
  return (0, _react2.useContext)(GridManagerContext);
};
var isOpenComponent = exports.isOpenComponent = function isOpenComponent(schema) {
  var _schema$xComponent10;
  return ((_schema$xComponent10 = schema['x-component']) === null || _schema$xComponent10 === void 0 ? void 0 : _schema$xComponent10.indexOf('Open')) > -1;
};
var Navigation = exports.Navigation = /*#__PURE__*/(0, _react2.memo)(/*#__PURE__*/(0, _react2.forwardRef)(function (props, ref) {
  var _array$field;
  var record = _antdV.ArrayBase.useRecord();
  var self = (0, _react.useField)();
  var array = _antdV.ArrayBase.useArray();
  var prefixCls = (0, _builtins__.usePrefixCls)('formily-array-advance-table');
  var _useStyle = (0, _style["default"])(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var editor = (0, _hooks.useEditor)();
  if (!array) return null;
  if (((_array$field = array.field) === null || _array$field === void 0 ? void 0 : _array$field.pattern) !== 'editable') return null;
  return wrapSSR(/*#__PURE__*/_react2["default"].createElement(_button["default"], (0, _extends3["default"])({
    type: "ghost"
  }, props, {
    style: (0, _extends3["default"])({
      width: 'auto',
      height: 'auto'
    }, props.style),
    disabled: self === null || self === void 0 ? void 0 : self.disabled,
    className: (0, _classnames["default"])(prefixCls + "-navigation", hashId, self !== null && self !== void 0 && self.disabled ? prefixCls + "-navigation-disabled" : '', props.className),
    ref: ref,
    onClick: function onClick(e) {
      var _editor$get, _editor$get$currentDo, _editor$get$currentDo2;
      if (self !== null && self !== void 0 && self.disabled || !record) return;
      var nodeId = record[LOWCODE_NODE_ID];
      (_editor$get = editor.get('project')) === null || _editor$get === void 0 ? void 0 : (_editor$get$currentDo = _editor$get.currentDocument) === null || _editor$get$currentDo === void 0 ? void 0 : (_editor$get$currentDo2 = _editor$get$currentDo.getNodeById(nodeId)) === null || _editor$get$currentDo2 === void 0 ? void 0 : _editor$get$currentDo2.select();
      e.stopPropagation();
      if (props.onClick) {
        props.onClick(e);
        if (e.defaultPrevented) return;
      }
    },
    icon: (0, _shared.isUndef)(props.icon) ? /*#__PURE__*/_react2["default"].createElement(_icons.EditOutlined, null) : props.icon
  }), props.title || self.title));
}));
var Column = exports.Column = function Column() {
  return /*#__PURE__*/_react2["default"].createElement(_react2.Fragment, null);
};
var SidePanel = exports.SidePanel = function SidePanel(props) {
  return props.children;
};
var Addition = exports.Addition = /*#__PURE__*/(0, _react2.memo)(function (props) {
  var _array$field2, _array$field3;
  var selected = (0, _hooks.useSelected)();
  var self = (0, _react.useField)();
  var array = _antdV.ArrayBase.useArray();
  var valueMode = useValueMode();
  var prefixCls = (0, _builtins__.usePrefixCls)('formily-array-advance-table');
  var _useStyle2 = (0, _style["default"])(prefixCls),
    wrapSSR = _useStyle2[0],
    hashId = _useStyle2[1];
  if (!array) return null;
  if (((_array$field2 = array.field) === null || _array$field2 === void 0 ? void 0 : _array$field2.pattern) !== 'editable' && ((_array$field3 = array.field) === null || _array$field3 === void 0 ? void 0 : _array$field3.pattern) !== 'disabled') return null;
  var value = array.field.value;
  var fieldNames = array.field.componentProps.fieldNames || {
    label: 'label',
    value: 'value'
  };
  return wrapSSR(/*#__PURE__*/_react2["default"].createElement(_button["default"], (0, _extends3["default"])({
    color: "primary",
    variant: "filled",
    size: "small"
  }, props, {
    disabled: self === null || self === void 0 ? void 0 : self.disabled,
    className: (0, _classnames["default"])(prefixCls + "-addition", hashId, props.className),
    onClick: function onClick(e) {
      var _array$props, _extends2;
      if ((_array$props = array.props) !== null && _array$props !== void 0 && _array$props.disabled) return;
      var defaultValue = (0, _extends3["default"])((_extends2 = {}, _extends2[indexKey] = value.length, _extends2), props.defaultValue);
      if (valueMode === 'children') {
        var _selected$document;
        var addNode = (_selected$document = selected.document) === null || _selected$document === void 0 ? void 0 : _selected$document.insertNode(selected, {
          componentName: 'Input',
          props: defaultValue
        });
        defaultValue[LOWCODE_NODE_ID] = addNode.id;
        console.log('--defaultValue', props, defaultValue);
        addNode.setPropValue(fieldNames.label, addNode.title + '');
        addNode.setPropValue(fieldNames.value, addNode.id);
        (0, _lodash.set)(defaultValue, fieldNames.label, addNode.title);
        (0, _lodash.set)(defaultValue, fieldNames.value, addNode.id);
      }
      if (props.method === 'unshift') {
        var _array$field4, _array$field4$unshift, _array$props2, _array$props2$onAdd;
        (_array$field4 = array.field) === null || _array$field4 === void 0 ? void 0 : (_array$field4$unshift = _array$field4.unshift) === null || _array$field4$unshift === void 0 ? void 0 : _array$field4$unshift.call(_array$field4, defaultValue);
        (_array$props2 = array.props) === null || _array$props2 === void 0 ? void 0 : (_array$props2$onAdd = _array$props2.onAdd) === null || _array$props2$onAdd === void 0 ? void 0 : _array$props2$onAdd.call(_array$props2, 0);
      } else {
        var _array$field5, _array$field5$push, _array$props3, _array$props3$onAdd, _array$field6, _array$field6$value;
        (_array$field5 = array.field) === null || _array$field5 === void 0 ? void 0 : (_array$field5$push = _array$field5.push) === null || _array$field5$push === void 0 ? void 0 : _array$field5$push.call(_array$field5, defaultValue);
        (_array$props3 = array.props) === null || _array$props3 === void 0 ? void 0 : (_array$props3$onAdd = _array$props3.onAdd) === null || _array$props3$onAdd === void 0 ? void 0 : _array$props3$onAdd.call(_array$props3, (array === null || array === void 0 ? void 0 : (_array$field6 = array.field) === null || _array$field6 === void 0 ? void 0 : (_array$field6$value = _array$field6.value) === null || _array$field6$value === void 0 ? void 0 : _array$field6$value.length) - 1);
      }
      if (props.onClick) {
        props.onClick(e);
      }
    },
    icon: (0, _shared.isUndef)(props.icon) ? /*#__PURE__*/_react2["default"].createElement(_icons.PlusOutlined, null) : props.icon
  }), props.title || self.title));
});
var BatchRemove = exports.BatchRemove = /*#__PURE__*/(0, _react2.memo)(function (props) {
  var _array$field7, _array$field8;
  var rowSelected = useRowSelectedContext();
  var selected = (0, _hooks.useSelected)();
  var self = (0, _react.useField)();
  var array = _antdV.ArrayBase.useArray();
  var valueMode = useValueMode();
  var prefixCls = (0, _builtins__.usePrefixCls)('formily-array-advance-table');
  var _useStyle3 = (0, _style["default"])(prefixCls),
    wrapSSR = _useStyle3[0],
    hashId = _useStyle3[1];
  if (!array) return null;
  if (((_array$field7 = array.field) === null || _array$field7 === void 0 ? void 0 : _array$field7.pattern) !== 'editable' && ((_array$field8 = array.field) === null || _array$field8 === void 0 ? void 0 : _array$field8.pattern) !== 'disabled') return null;
  return wrapSSR(/*#__PURE__*/_react2["default"].createElement(_button["default"], (0, _extends3["default"])({
    color: "danger",
    variant: "filled",
    size: "small"
  }, props, {
    disabled: (self === null || self === void 0 ? void 0 : self.disabled) || rowSelected.length === 0,
    className: (0, _classnames["default"])(prefixCls + "-remove", hashId, self !== null && self !== void 0 && self.disabled ? prefixCls + "-remove-disabled" : '', props.className),
    onClick: function onClick(e) {
      if (self !== null && self !== void 0 && self.disabled) return;
      e.stopPropagation();
      if (props.onClick) {
        props.onClick(e);
        if (e.defaultPrevented) return;
      }
      var value = array.field.value;
      rowSelected.forEach(function (key) {
        var index = value.findIndex(function (item) {
          return item[LOWCODE_NODE_ID] === key;
        });
        if (index > -1) {
          var _array$field9, _array$field9$remove, _array$props4, _array$props4$onRemov;
          if (valueMode === 'children') {
            var _selected$children$ge;
            (_selected$children$ge = selected.children.get(index)) === null || _selected$children$ge === void 0 ? void 0 : _selected$children$ge.remove();
          }
          (_array$field9 = array.field) === null || _array$field9 === void 0 ? void 0 : (_array$field9$remove = _array$field9.remove) === null || _array$field9$remove === void 0 ? void 0 : _array$field9$remove.call(_array$field9, index);
          (_array$props4 = array.props) === null || _array$props4 === void 0 ? void 0 : (_array$props4$onRemov = _array$props4.onRemove) === null || _array$props4$onRemov === void 0 ? void 0 : _array$props4$onRemov.call(_array$props4, index);
        }
      });
    },
    icon: props.icon
  }), props.title || self.title));
});
var isActionComponent = exports.isActionComponent = function isActionComponent(schema) {
  var _schema$xComponent11;
  return ((_schema$xComponent11 = schema['x-component']) === null || _schema$xComponent11 === void 0 ? void 0 : _schema$xComponent11.indexOf('Action')) > -1;
};
var isBatchRemoveComponent = exports.isBatchRemoveComponent = function isBatchRemoveComponent(schema) {
  var _schema$xComponent12;
  return ((_schema$xComponent12 = schema['x-component']) === null || _schema$xComponent12 === void 0 ? void 0 : _schema$xComponent12.indexOf('BatchRemove')) > -1;
};
var Action = exports.Action = function Action(_ref2) {
  var children = _ref2.children;
  return children;
};
var useAction = exports.useAction = function useAction(schema) {
  return schema.reduceProperties(function (addition, schema, key) {
    if (isActionComponent(schema)) {
      return /*#__PURE__*/_react2["default"].createElement(_react.RecursionField, {
        schema: schema,
        name: key
      });
    }
    return addition;
  }, null);
};
var useBatchRemove = exports.useBatchRemove = function useBatchRemove(schema) {
  return schema.reduceProperties(function (batchRemove, schema, key) {
    if (isBatchRemoveComponent(schema)) {
      return /*#__PURE__*/_react2["default"].createElement(_react.RecursionField, {
        schema: schema,
        name: key
      });
    }
    return batchRemove;
  }, null);
};