"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.SideContent = void 0;
var _drawer = _interopRequireDefault(require("antd/lib/drawer"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _button = _interopRequireDefault(require("antd/lib/button"));
var _react = require("@formily/react");
var _classnames = _interopRequireDefault(require("classnames"));
var _react2 = require("react");
var _style = _interopRequireDefault(require("./style"));
var _builtins__ = require("@formily/antd-v5/lib/__builtins__");
var _antdV = require("@formily/antd-v5");
var _common = require("../common");
var _context = require("../../../context");
var _validatorSetter = require("../validator-setter");
var SideContent = exports.SideContent = (0, _react.observer)(function (props) {
  var array = _antdV.ArrayBase.useArray();
  var schema = (0, _react.useFieldSchema)();
  var _useState = (0, _react2.useState)(false),
    open = _useState[0],
    setOpen = _useState[1];
  var slotRef = (0, _context.useSubSlotRef)();
  var prefixCls = (0, _builtins__.usePrefixCls)('side-content-drawer', props);
  var _useStyle = (0, _style["default"])(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  if (!schema) throw new Error('can not found schema object');
  var itemsSchema = Array.isArray(array.schema.items) ? array.schema.items[0] : array.schema.items;
  var _props = {
    title: ''
  };
  itemsSchema.mapProperties(function (schema) {
    if ((0, _common.isSidePanelComponent)(schema)) {
      _props = schema['x-component-props'];
    }
  });
  return wrapSSR(/*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_button["default"], {
    color: "primary",
    variant: "filled",
    size: "small",
    onClick: function onClick() {
      setOpen(true);
    }
  }, _props.title), /*#__PURE__*/React.createElement(_drawer["default"], {
    width: 400,
    open: open,
    rootStyle: {
      position: 'absolute'
    },
    push: false,
    onClose: function onClose() {
      return setOpen(false);
    },
    getContainer: function getContainer() {
      return slotRef.current;
    },
    mask: false,
    rootClassName: (0, _classnames["default"])(prefixCls, hashId),
    classNames: {
      header: prefixCls + "-drawer-header"
    }
  }, /*#__PURE__*/React.createElement(_validatorSetter.ValidatorSetter, (0, _extends2["default"])({
    setOpen: setOpen
  }, _props)))));
});