"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.MixedSetter = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _button = _interopRequireDefault(require("antd/lib/button"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _builtins__ = require("@formily/antd-v5/lib/__builtins__");
var _react = require("@formily/react");
var _shared = require("@formily/shared");
var _classnames = _interopRequireDefault(require("classnames"));
var _style = require("./style");
var _lowcodeUtils = require("@gant-lowcode/lowcode-utils");
var _useEvent = require("../../../../hooks/useEvent");
var _hooks = require("../../../../hooks");
var _antdV = require("@formily/antd-v5");
var _react2 = require("react");
var _excluded = ["className", "style", "children", "buttonProps"];
var isHTMLInputEvent = function isHTMLInputEvent(event, stopPropagation) {
  if (stopPropagation === void 0) {
    stopPropagation = true;
  }
  if (event !== null && event !== void 0 && event.target) {
    var _event$stopPropagatio;
    if (typeof event.target === 'object' && ('value' in event.target || 'checked' in event.target)) return true;
    if (stopPropagation) (_event$stopPropagatio = event.stopPropagation) === null || _event$stopPropagatio === void 0 ? void 0 : _event$stopPropagatio.call(event);
  }
  return false;
};
var getValuesFromEvent = function getValuesFromEvent(args) {
  return args.map(function (event) {
    if (event !== null && event !== void 0 && event.target) {
      if ((0, _shared.isValid)(event.target.value)) return event.target.value;
      if ((0, _shared.isValid)(event.target.checked)) return event.target.checked;
      return;
    }
    return event;
  });
};
var getValues = function getValues(args) {
  var _args$;
  if ((_args$ = args[0]) !== null && _args$ !== void 0 && _args$.target) {
    if (!isHTMLInputEvent(args[0])) return args;
  }
  return getValuesFromEvent(args);
};
var MixedSetter = exports.MixedSetter = (0, _react.observer)(function (_ref) {
  var className = _ref.className,
    style = _ref.style,
    children = _ref.children,
    buttonProps = _ref.buttonProps,
    props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  var event = (0, _useEvent.useEvent)();
  var field = (0, _react.useField)();
  var selected = (0, _hooks.useSelected)();
  var prefixCls = (0, _builtins__.usePrefixCls)('mixed-setter');
  var _useStyle = (0, _style.useStyle)(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var getMockOrValue = function getMockOrValue(v) {
    if ((0, _lowcodeUtils.isJSExpression)(v)) {
      return v.mock;
    }
    return v;
  };
  var _useMemo = (0, _react2.useMemo)(function () {
      var oldOnInput = field.onInput;
      var oldValue = field.value ? JSON.parse(JSON.stringify(field.value)) : undefined;
      var onInput = /*#__PURE__*/function () {
        var _ref2 = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee() {
          var _len,
            args,
            _key,
            values,
            value,
            _args = arguments;
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) switch (_context.prev = _context.next) {
              case 0:
                for (_len = _args.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
                  args[_key] = _args[_key];
                }
                console.log('--onChange-args', args);
                values = getValues(args);
                value = values[0];
                console.log('--onChange-value', value);
                if ((0, _lowcodeUtils.isJSExpression)(oldValue)) {
                  oldOnInput === null || oldOnInput === void 0 ? void 0 : oldOnInput((0, _extends2["default"])({}, oldValue, {
                    mock: value
                  }));
                } else {
                  oldOnInput === null || oldOnInput === void 0 ? void 0 : oldOnInput(value);
                }
              case 6:
              case "end":
                return _context.stop();
            }
          }, _callee);
        }));
        return function onInput() {
          return _ref2.apply(this, arguments);
        };
      }();
      field.onInput = onInput;
      field.value = getMockOrValue(oldValue);
      return {
        oldValue: oldValue,
        oldOnInput: oldOnInput
      };
    }, []),
    oldValue = _useMemo.oldValue,
    oldOnInput = _useMemo.oldOnInput;
  var onBindChange = function onBindChange(value) {
    console.log('-onBindChange--value', value, oldOnInput);
    oldOnInput === null || oldOnInput === void 0 ? void 0 : oldOnInput(value);
  };
  var show = function show() {
    // 打开绑定变量面板
    event.emit('variableBind.open', (0, _extends2["default"])({}, props, {
      onChange: onBindChange
    }), field, selected);
  };
  var extra = /*#__PURE__*/React.createElement(_button["default"], (0, _extends2["default"])({
    size: "small"
  }, buttonProps, {
    onClick: show
  }), (0, _lowcodeUtils.createIcon)('fx', {
    className: (0, _classnames["default"])(prefixCls + "-icon", {
      active: (0, _lowcodeUtils.isJSExpression)(oldValue)
    }),
    style: {
      fontSize: 12
    }
  }));
  return wrapSSR(/*#__PURE__*/React.createElement(_antdV.FormItem, (0, _extends2["default"])({
    className: (0, _classnames["default"])(prefixCls, hashId, className),
    style: style
  }, props, {
    extra: extra
  }), children));
});