"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.ValidatorSetter = void 0;
var _tabs = _interopRequireDefault(require("antd/lib/tabs"));
var _empty = _interopRequireDefault(require("antd/lib/empty"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _react = require("@formily/react");
var _classnames = _interopRequireDefault(require("classnames"));
var _react2 = _interopRequireWildcard(require("react"));
var _style = _interopRequireDefault(require("./style"));
var _builtins__ = require("@formily/antd-v5/lib/__builtins__");
var _lodash = require("lodash");
var _hooks = require("../../../../hooks");
var _shared = require("@formily/shared");
var _excluded = ["className", "fieldNames", "children"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var ValidatorSetter = exports.ValidatorSetter = (0, _react.observer)(function (props) {
  var className = props.className,
    _props$fieldNames = props.fieldNames,
    fieldNames = _props$fieldNames === void 0 ? {
      label: 'label',
      value: 'value'
    } : _props$fieldNames,
    children = props.children,
    restProps = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded);
  console.log('ValidatorSetter-----props', props);
  var field = (0, _react.useField)();
  var schema = (0, _react.useFieldSchema)();
  console.log('-ValidatorSetter--schema', schema.toJSON(), field);
  var form = field.form;
  var selected = (0, _hooks.useSelected)();
  var _useState = (0, _react2.useState)(),
    stateActiveTabKey = _useState[0],
    setStateActiveTabKey = _useState[1];
  var prefixCls = (0, _builtins__.usePrefixCls)('validator-setter', props);
  var _useStyle = (0, _style["default"])(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var onTabChange = function onTabChange(key) {
    setStateActiveTabKey(key);
  };
  if (!schema) throw new Error('can not found schema object');
  var definitions = selected.getStatementStateDefinitions();
  var isStateRules = definitions && !(0, _lodash.isEmpty)(definitions);
  var itemsSchema = new _react.Schema(schema.toJSON(), schema.parent);
  console.log('---definitions', definitions, isStateRules, itemsSchema.toJSON());
  var basePath = '';
  schema.mapProperties(function (item, key) {
    basePath = key.toString();
  });
  var currentTabKey = '';
  var tabList = undefined;
  if (isStateRules) {
    var _Object$keys;
    currentTabKey = stateActiveTabKey || ((_Object$keys = Object.keys(definitions)) === null || _Object$keys === void 0 ? void 0 : _Object$keys[0]);
    basePath = basePath + "__state__." + currentTabKey;
    tabList = Object.entries(definitions).map(function (_ref) {
      var key = _ref[0],
        label = _ref[1];
      return {
        key: key,
        label: label
      };
    });
    // 构建状态 schema
    itemsSchema.mapProperties(function (schema, key) {
      var _properties, _stateSchema;
      var stateSchema = (_stateSchema = {}, _stateSchema[key + "__state__"] = {
        type: 'object',
        properties: (_properties = {}, _properties[currentTabKey] = schema.toJSON(), _properties)
      }, _stateSchema);
      itemsSchema.setProperties(stateSchema);
      itemsSchema.removeProperty(key);
    });
  }
  var value = _shared.FormPath.getIn(form.values, basePath) || [];
  var isRuleEmpty = value.length === 0;
  var renderEmpty = function renderEmpty() {
    if (!isRuleEmpty) return;
    return /*#__PURE__*/_react2["default"].createElement(_empty["default"], {
      description: "\u6682\u65E0\u6821\u9A8C\u89C4\u5219"
    });
  };
  var renderItems = function renderItems() {
    return /*#__PURE__*/_react2["default"].createElement(_react.RecursionField, {
      schema: itemsSchema
    });
  };
  return wrapSSR(/*#__PURE__*/_react2["default"].createElement("div", {
    className: (0, _classnames["default"])(prefixCls, hashId)
  }, tabList && tabList.length > 0 && /*#__PURE__*/_react2["default"].createElement(_tabs["default"], {
    className: prefixCls + "-tabs",
    items: tabList,
    size: "small",
    onChange: onTabChange,
    tabBarGutter: 12
  }), renderEmpty(), renderItems()));
});