"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.SettingsForm = SettingsForm;
var _react = _interopRequireWildcard(require("react"));
var _core = require("@formily/core");
var _classnames = _interopRequireDefault(require("classnames"));
var _lodash = require("lodash");
var _builtins__ = require("@formily/antd-v5/lib/__builtins__");
var _schemaField = require("./schema-field");
var _hooks = require("../../../hooks");
var _utils = require("./utils");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function SettingsForm(_ref) {
  var className = _ref.className,
    style = _ref.style,
    settings = _ref.settings,
    schema = _ref.schema,
    components = _ref.components,
    scope = _ref.scope;
  var formWrapperCls = (0, _builtins__.usePrefixCls)('settings-form-wrapper');
  var material = (0, _hooks.useMaterial)();
  var form = (0, _react.useMemo)(function () {
    var _component$snippets, _component$snippets$, _component$snippets$$;
    var values = settings.getValue();
    var assets = material.getAssets();
    var _settings$getNode = settings.getNode(),
      componentName = _settings$getNode.componentName;
    var component = assets.components.find(function (item) {
      return item.componentName === componentName;
    });
    var initialValues = component === null || component === void 0 ? void 0 : (_component$snippets = component.snippets) === null || _component$snippets === void 0 ? void 0 : (_component$snippets$ = _component$snippets[0]) === null || _component$snippets$ === void 0 ? void 0 : (_component$snippets$$ = _component$snippets$.schema) === null || _component$snippets$$ === void 0 ? void 0 : _component$snippets$$.props;
    console.log('SettingsForm---initialValues', initialValues);
    console.log('SettingsForm---values', values, settings.getNode());
    return (0, _core.createForm)({
      initialValues: initialValues,
      values: values,
      effects: function effects() {
        var valueChange = function valueChange(field) {
          if ((0, _lodash.get)(field.data, 'virtual') === true || (0, _lodash.get)(field.parent.data, 'virtual') === true) return;
          var value = field.value;
          var key = field.path.toString();
          console.log('---key, value', key, value);
          settings.setPropValue(key, value);
        };
        (0, _utils.onFieldDiffValueChange)('*', valueChange);
      }
    });
  }, [settings]);
  return /*#__PURE__*/_react["default"].createElement(_schemaField.Form, {
    className: (0, _classnames["default"])('lc-settings-form', formWrapperCls, className),
    form: form,
    style: style,
    labelAlign: "left",
    feedbackLayout: "terse",
    labelCol: 6,
    colon: false
  }, /*#__PURE__*/_react["default"].createElement(_schemaField.SchemaField, {
    schema: schema,
    components: components,
    scope: scope
  }));
}